SystemOrganization addCategory: #'Smallchange-Test-Core'!
SystemOrganization addCategory: #'Smallchange-Test-Core-Commands'!

TestCase subclass: #TestScCommands
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Core'!

!TestScCommands methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/22/2012 14:18'!
testScAddAccount
	[ :profile :account | | command |
		[ ( ScAddAccount profile: profile account: account) do]  should strictly satisfy: [
			profile addAccount: account ] ] runScenario! !

!TestScCommands methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/22/2012 14:02'!
testScAddPool
	[ :profile :pool | 
		[ (ScAddPool profile: profile pool: pool) do]  should strictly satisfy: [
			profile addPool: pool ] ] runScenario! !

!TestScCommands methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/22/2012 15:48'!
testUndoScAddAccount
	[ :profile :account | | command |
		command := ScAddAccount profile: profile account: account.
		 [command undo ]  should strictly satisfy: [
			profile removeAccount: account ] ] runScenario! !

!TestScCommands methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/22/2012 15:49'!
testUndoScAddPool
	[ :profile :pool | | command |
		command := ScAddPool profile: profile pool: pool.
		[command undo ]  should strictly satisfy: [
			profile removePool: pool ] ] runScenario! !

TestCase subclass: #TestScPool
	instanceVariableNames: 'profile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Core'!

!TestScPool methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/7/2012 21:50'!
newPool
	^ScPool profile: profile! !

!TestScPool methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/7/2012 21:49'!
setUp
	profile := ScProfile name: 'test'.
	profile addAccount: (ScAccount new name: 'account'; yourself).! !

!TestScPool methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/7/2012 21:49'!
testDefaultAccountMustExistInProfile
	[self newPool defaultAccount: ScAccount new ] 
		should raise: MbValidationError! !

TestCase subclass: #TestScProfile
	instanceVariableNames: 'profile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Core'!

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/18/2012 20:44'!
setUp
	profile := ScProfile name: 'test'! !

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/22/2012 14:16'!
testAddAccount
	[ :account | 
		profile addAccount: account ] runScenario.
	self assert: profile accounts size equals: 1

! !

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/18/2012 21:19'!
testAddAccountWithSameNameFails
	profile addAccount: (ScAccount new name: 'foo'; yourself).
	self should: [ profile addAccount: (ScAccount new name: 'foo'; yourself)] raise: MbValidationError! !

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/22/2012 14:10'!
testAddPool
	[ :pool | 
		profile addPool: pool ] runScenario.
	self assert: profile pools size equals: 1! !

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/18/2012 21:19'!
testAddPoolWithSameNameFails
	profile addPool: (ScPool new name: 'foo'; yourself).
	self should: [ profile addPool: (ScPool new name: 'foo'; yourself)] raise: MbValidationError! !

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/22/2012 14:16'!
testRemoveAccount
	[ :account | 
		profile addAccount: account.
		profile removeAccount: account ] runScenario.
	self assert: profile accounts isEmpty

! !

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/22/2012 14:16'!
testRemovePool
	[:pool |
		profile addPool: pool.
		profile removePool: pool] runScenario.
	self assert: profile pools isEmpty

! !

TestCase subclass: #TestScRecordTransaction
	instanceVariableNames: 'profile account pool transaction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Core-Commands'!

!TestScRecordTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 20:28'!
setUp
	profile := ScProfile name: 'Test'.
	account :=  profile newAccount.
	pool := profile newPool.
	profile addAccount: account.
	profile addPool: pool.
	transaction := profile newTransaction
		account: account;
		pool: pool;
		amount: 12.34;
		yourself! !

!TestScRecordTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 20:52'!
testRecordTransactionAddsToAccount
	(ScRecordTransaction profile: profile transaction: transaction) do.
	account transactions should include: transaction.! !

!TestScRecordTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 20:52'!
testRecordTransactionAddsToPool
	(ScRecordTransaction profile: profile transaction: transaction) do.
	pool transactions should include: transaction.! !

!TestScRecordTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 20:40'!
testRecordTransactionAddsToProfile
	[ :p | [ (ScRecordTransaction profile: p transaction: transaction) do ] 
		should strictly satisfy: [ p addTransaction: transaction ]] runScenario
! !

!TestScRecordTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 20:55'!
testRecordTransactionWithNoPoolSucceeds
	transaction pool: nil.
	(ScRecordTransaction profile: profile transaction: transaction) do.
! !

!TestScRecordTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 20:53'!
testUndoRecordTransactionRemovesFromAccount
	(ScRecordTransaction profile: profile transaction: transaction) do; undo.
	account transactions shouldnt include: transaction.! !

!TestScRecordTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 20:53'!
testUndoRecordTransactionRemovesFromPool
	(ScRecordTransaction profile: profile transaction: transaction) do; undo.
	pool transactions shouldnt include: transaction.! !

!TestScRecordTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 21:07'!
testUndoRecordTransactionRemovesFromProfile
	[ :p |  |  command | 
		command := (ScRecordTransaction profile: p transaction: transaction).
		account addTransaction: transaction.
		transaction pool: nil.
		[ command undo] 
			should strictly satisfy: [ p removeTransaction: transaction ]] runScenario! !

TestCase subclass: #TestScTransaction
	instanceVariableNames: 'profile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Core'!

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 18:35'!
newTransaction
	^profile newTransaction! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/29/2012 10:46'!
setUp
	profile := ScProfile name: 'test'.
	profile addAccount: (ScAccount new name: 'account'; yourself).
	profile addPool: (ScPool new name: 'pool'; yourself)! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 18:23'!
testTransactionAccountMustExistInProfile
	[self newTransaction account: ScAccount new ] 
		should raise: MbValidationError! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 18:23'!
testTransactionAccountMustExistInProfileSuccess
	[self newTransaction account: profile accounts first ] 
		should not raise: MbValidationError! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 18:23'!
testTransactionCanHaveNoPool
	[ self newTransaction pool: nil ] 
		should not raise: MbValidationError! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 18:23'!
testTransactionMustHaveAccount
	[ self newTransaction account: nil ] 
		should raise: MbRequiredFieldError! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 18:30'!
testTransactionPoolMustExistInProfile
	[ self newTransaction pool: ScPool new ]  
		should raise: MbValidationError! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 18:23'!
testTransactionPoolMustExistInProfileSuccess
	[ self newTransaction pool: profile pools first ] 
		should not raise: MbValidationError! !
